<template>
  <basic-container>
    <avue-crud :option="option"
               :table-loading="loading"
               :data="data"
               :page.sync="page"
               :permission="permissionList"
               :before-open="beforeOpen"
               v-model="form"
               ref="crud"
               @row-update="rowUpdate"
               @row-save="rowSave"
               @row-del="rowDel"
               @search-change="searchChange"
               @search-reset="searchReset"
               @selection-change="selectionChange"
               @current-change="currentChange"
               @size-change="sizeChange"
               @refresh-change="refreshChange"
               @on-load="onLoad">

     <template slot="userInfo" slot-scope="scope">
        <div style="display: flex;">
          <div style="display: flex;justify-content: center;align-items: center;">
            <el-avatar size="large" :src="scope.row.avatar"></el-avatar>
          </div>
           <div style="padding: 10px;">
             <div >昵称：{{scope.row.nickName}}</div>
             <div>手机：{{scope.row.phone}}</div>
           </div>
        </div>
      </template>

      <template slot="pointsValue" slot-scope="scope">
        <el-tag effect="dark" v-if="scope.row.pointsValue>0">+{{scope.row.pointsValue}}</el-tag>
        <el-tag effect="dark" v-else type="danger">{{scope.row.pointsValue}}</el-tag>
      </template>

      <template slot="pointsDesc" slot-scope="scope">
        <div v-if="scope.row.type==1">作品打赏</div>
        <div v-if="scope.row.type==2">作者打赏</div>
        <div v-if="scope.row.type==3">兑换勋章</div>
        <div v-if="scope.row.type==4">捐赠物品</div>
        <div v-if="scope.row.type==5">兑换商品</div>
      </template>

      <template slot="menuLeft">
        <el-button type="danger"
                   size="small"
                   icon="el-icon-delete"
                   plain
                   v-if="permission.pointsdetail_delete"
                   @click="handleDelete">删 除
        </el-button>
      </template>
    </avue-crud>
  </basic-container>
</template>

<script>
  import {getList, getDetail, add, update, remove} from "@/api/pointsdetail/pointsdetail";
  import {mapGetters} from "vuex";

  export default {
    data() {
      return {
        form: {},
        query: {},
        loading: true,
        page: {
          pageSize: 10,
          currentPage: 1,
          total: 0
        },
        selectionList: [],
        option: {
          height:'auto',
          calcHeight: 30,
          tip: false,
          searchShow: true,
          searchMenuSpan: 6,
          border: true,
          index: true,
          viewBtn: true,
          selection: true,
          dialogClickModal: false,
          column: [
            {
              label: "用户id",
              prop: "userId",
              hide:true,
              rules: [{
                required: true,
                message: "请输入用户id",
                trigger: "blur"
              }]
            },
            {
              label:"用户信息",
              slot:true,
              prop:"userInfo"
            },
            {
              label:"用户昵称",
              prop:"nickName",
              search:true
            },
            {
              label:"手机号",
              prop:"phone",
              search:true
            },
            {
              label: "积分值",
              slot:true,
              prop: "pointsValue",
              rules: [{
                required: true,
                message: "请输入积分值",
                trigger: "blur"
              }]
            },
            {
              label: "1：作品打赏 2：作者打赏  3：兑换勋章 4：捐赠物品 5:兑换商品",
              prop: "type",
              hide:true,
              rules: [{
                required: true,
                message: "请输入1：作品打赏 2：作者打赏  3：兑换勋章 4：捐赠物品 5:兑换商品",
                trigger: "blur"
              }]
            },
            {
              slot:true,
              label:"积分详情",
              prop:'pointsDesc'
            },
            {
              label: "关联type的id",
              hide:true,
              prop: "relationId",
              rules: [{
                required: true,
                message: "请输入关联type的id",
                trigger: "blur"
              }]
            },
            {
              label: "备注",
              prop: "note",
              rules: [{
                required: true,
                message: "请输入备注",
                trigger: "blur"
              }]
            },
          ]
        },
        data: []
      };
    },
    computed: {
      ...mapGetters(["permission"]),
      permissionList() {
        return {
          addBtn: this.vaildData(this.permission.pointsdetail_add, false),
          viewBtn: this.vaildData(this.permission.pointsdetail_view, false),
          delBtn: this.vaildData(this.permission.pointsdetail_delete, false),
          editBtn: this.vaildData(this.permission.pointsdetail_edit, false)
        };
      },
      ids() {
        let ids = [];
        this.selectionList.forEach(ele => {
          ids.push(ele.id);
        });
        return ids.join(",");
      }
    },
    methods: {
      rowSave(row, done, loading) {
        add(row).then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          done();
        }, error => {
          loading();
          window.console.log(error);
        });
      },
      rowUpdate(row, index, done, loading) {
        update(row).then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          done();
        }, error => {
          loading();
          console.log(error);
        });
      },
      rowDel(row) {
        this.$confirm("确定将选择数据删除?", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        })
          .then(() => {
            return remove(row.id);
          })
          .then(() => {
            this.onLoad(this.page);
            this.$message({
              type: "success",
              message: "操作成功!"
            });
          });
      },
      handleDelete() {
        if (this.selectionList.length === 0) {
          this.$message.warning("请选择至少一条数据");
          return;
        }
        this.$confirm("确定将选择数据删除?", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        })
          .then(() => {
            return remove(this.ids);
          })
          .then(() => {
            this.onLoad(this.page);
            this.$message({
              type: "success",
              message: "操作成功!"
            });
            this.$refs.crud.toggleSelection();
          });
      },
      beforeOpen(done, type) {
        if (["edit", "view"].includes(type)) {
          getDetail(this.form.id).then(res => {
            this.form = res.data.data;
          });
        }
        done();
      },
      searchReset() {
        this.query = {};
        this.onLoad(this.page);
      },
      searchChange(params, done) {
        this.query = params;
        this.page.currentPage = 1;
        this.onLoad(this.page, params);
        done();
      },
      selectionChange(list) {
        this.selectionList = list;
      },
      selectionClear() {
        this.selectionList = [];
        this.$refs.crud.toggleSelection();
      },
      currentChange(currentPage){
        this.page.currentPage = currentPage;
      },
      sizeChange(pageSize){
        this.page.pageSize = pageSize;
      },
      refreshChange() {
        this.onLoad(this.page, this.query);
      },
      onLoad(page, params = {}) {
        this.loading = true;
        getList(page.currentPage, page.pageSize, Object.assign(params, this.query)).then(res => {
          const data = res.data.data;
          this.page.total = data.total;
          this.data = data.records;
          this.loading = false;
          this.selectionClear();
        });
      }
    }
  };
</script>

<style>
</style>
